function T=buildLPTFromCurve(n,m,dres,curve_cords,curve_vals,issps)

if (~exist('issps','var'))
  issps=1;
end
nstp=20*dres;


%since we use an horizontal over parametrization (by factor dres)
%we will low-pass the data such that there are no more than m/dres
%active frequancies. For camera famelies with a smaller spatial resolution 
%(e.g. stereo) we low-pass more 

%Build the low-pass filter
K=length(curve_vals);
dsmp=dres*K;
smpvar=dsmp*0.33;
%smpvar=dsmp*0.66;
f0=exp(-0.5*[-dsmp:dsmp].^2/smpvar^2);
f0=conv2(f0,ones(1,dsmp));
f0=f0/sum(f0)*K;

stpd=floor((length(f0)-dres*K)/2);
stpu=length(f0)-stpd-1;

%Here we build the low-pass matrix
avgM=getConvMat(1,m,f0(:),[0 0 -stpd stpu],1);

%If we have K different views, we subsample each view by factor K*dres 
avgM=avgM(1:dres*K:end,:);

 
%iterate over the views and build the T matrix.
T=[];
for k=1:K
  if (issps)
    T1=getTMatByCurve_w(n,m,curve_cords{k},curve_vals{k},dres,[1]);
  else
    T1=getTMatByCurve_full_w(n,m,curve_cords{k},curve_vals{k},dres,[1]);
  end
  T=[T;avgM*T1];
end

