function smpTestLF(slopes_len,mind,maxd,outdir)

dres=3;
n=35;m=36*dres;

frac_d=1/3;

mean_d=0.002;


dvals=[mind:frac_d:maxd];
dlen=length(dvals);

im=rgb2gray(double(imread('im0.ppm'))/255); 
im=im(1:280,1:215);
[im_n,im_m]=size(im);

itrsNum=20;

%jstpsC={[-3,-1.5,-1,-0.7,-0.5:0.1:-0.1,0.1:0.1:0.5,0.7,1,1.5,3]};
%sstpsC={0.6*[-5:-1,1:5]/n};
%jstpsC={[-3,-1,-0.5,-0.1,0.1,0.5,1,3]};
%sstpsC={[-3:-1,1:3]/n};

jstpsC={[-1,-0.5,0.5,1]};
sstpsC={[-2,-1,1,2]/n};


for itr=1:itrsNum

  %sample slopes_len slopes for this light field patch
  p=dvals(randperm(dlen));
  s_vals=sort(p(1:slopes_len));
  max_slopes_num=0;

  %sample the location of depth discontinuities
  while(max_slopes_num<(slopes_len))
    slopes=ones(1,m)*s_vals(1);
    for s=2:slopes_len
      j1=0; j2=0;
      while ((j2-j1)<(5*dres))
        j1=max(ceil(rand*m*(slopes_len-1)/slopes_len),2);
        j2=min(ceil(rand*m*(slopes_len-1)/slopes_len+1/slopes_len),m-1);
      end
      slopes(j1:j2)=s_vals(s);
    end
    depthj=find(diff(slopes));
    svals=[slopes(depthj),slopes(m)];
    max_slopes_num=length(unique(round(svals*10^10)));
  end

  %we build a matrix O, expressing the light field as a function of slopes_len 
  %central rows (one central row per layer). we do that for the true 
  %slope-field, and for some slop-fields permutations
  %Os is a cell array of central-rows to lightfields mapping, with the 
  %convention that the first entry corresponds to the true slope-field 
  %and the successive entries to slop-field permutations
  Os=permSlopesToOk(svals,depthj,n,m,mind,maxd,dres,frac_d,0,1,jstpsC,sstpsC);
 
 
  %sample texture for each layer
  hm=m/2+1;
  for t=1:max_slopes_num
    r_var=0;
    while(r_var<(mean_d*0.8))
      r_row=ceil(rand*im_n);
      r_col=ceil(rand*(im_m-hm));
      x0=im(r_row,r_col+1:r_col+hm);
      x0=x0([1:end,end-1:-1:2]);
      r_var=mean(diff(x0).^2);
    end
    x0=x0/(r_var/mean_d)^0.5;
    %mean(diff(x0).^2)
    x0L(:,t)=x0(:);
  end

  %given a texture for each layer, and central-row to full-lightfield
  %mapping, build the full lightfield

  true_x=reshape(Os{1}*(x0L(:)),n,m);
  %figure, imshow(true_x)
  
  eval(sprintf('save %s/exmp%03d.mat true_x Os x0L  ',outdir,itr))
end
